/*
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Alessandro Pozzi <signor.hyde@gmail.com>
 */

Qt.include("../common/ClockUtils.js")

var weekdaysvisible = true,
    oneAlarm = new Array,
    selectkey;

function checkAlarm () {
    var hoursnow = Qt.formatDateTime(new Date(), "hh"),
        minutesnow = Qt.formatDateTime(new Date(), "mm"),
        secondsnow = Qt.formatDateTime(new Date(), "ss"),
        x, y;

    for (x = 0; x < oneAlarm.length; x++) {
        for (y = 0; y < oneAlarm[0].length; y++) {
            if (oneAlarm[x][1] == hoursnow && oneAlarm[x][2] == minutesnow && secondsnow == 0) {
                clockOuterCircle.glowColor = Constants.analogClockFaceGlowColorTimerDown;
                storageAlarm.setStateAlarmValue(oneAlarm[x][0], 0);
                alarmPage.timerOn = false;
            }
        }
    }
}

function showWeekday (mode) {
    itemMon.visible = mode;
    itemTue.visible = mode;
    itemWed.visible = mode;
    itemThu.visible = mode;
    itemFri.visible = mode;
    itemSat.visible = mode;
    itemSun.visible = mode;
    weekdaysvisible = mode;
}

function checkampm (oldhou, hou, ampm) {
    if (oldhou == 11 && hou == 0 && ampm == "AM") {
        alarmPage.ampm = "PM";
        alarmPage.morehours = 12;
    }
    else if (oldhou == 11 && hou == 0 && ampm == "PM") {
        alarmPage.ampm = "AM";
        alarmPage.morehours = 0;
    }
    else if (oldhou == 0 && hou == 11 && ampm == "AM") {
        alarmPage.ampm = "PM";
        alarmPage.morehours = 12;
    }
    else if (oldhou == 0 && hou == 11 && ampm == "PM") {
        alarmPage.ampm = "AM";
        alarmPage.morehours = 0;
    }
}

function editAlarm (key) {
    var selectedAlarm = new Array;
    selectedAlarm = storageAlarm.getSingleAlarmValue(key);

    circleMinutes.state = "UPDATE";

    selectkey = selectedAlarm[0][0];
    hourValue = selectedAlarm[0][1];
    minuteValue = selectedAlarm[0][2];

    hourslabelTimer.text = zeroleft(hourValue, 2);
    minuteslabelTimer.text =  zeroleft(minuteValue, 2);

    var angleHour = (parseInt(selectedAlarm[0][1]) > 12) ? parseInt(selectedAlarm[0][1]) - 12 : parseInt(selectedAlarm[0][1]);
    hourHand.rotationAngle = angleHour * 30;
    minuteHand.rotationAngle = parseInt(selectedAlarm[0][2]) * 6;

    checkMon.checked = (selectedAlarm[0][3] == 1) ? true : false;
    checkTue.checked = (selectedAlarm[0][4] == 1) ? true : false;
    checkWed.checked = (selectedAlarm[0][5] == 1) ? true : false;
    checkThu.checked = (selectedAlarm[0][6] == 1) ? true : false;
    checkFri.checked = (selectedAlarm[0][7] == 1) ? true : false;
    checkSat.checked = (selectedAlarm[0][8] == 1) ? true : false;
    checkSun.checked = (selectedAlarm[0][9] == 1) ? true : false;
    showWeekday(true);

    listTone.selectedIndex = selectedAlarm[0][10];
    vibrateSwitch.checked = (selectedAlarm[0][11] == 1) ? true : false;
}

function updateAlarm (alarmkey) {
    var key = alarmkey,
        hou = alarmPage.hourValue + alarmPage.morehours,
        min = alarmPage.minuteValue,
        mon = (checkMon.checked == true) ? 1 : 0,
        tue = (checkTue.checked == true) ? 1 : 0,
        wed = (checkWed.checked == true) ? 1 : 0,
        thu = (checkThu.checked == true) ? 1 : 0,
        fri = (checkFri.checked == true) ? 1 : 0,
        sat = (checkSat.checked == true) ? 1 : 0,
        sun = (checkSun.checked == true) ? 1 : 0,
        tone = listTone.selectedIndex,
        vibrate = (vibrateSwitch.checked == true) ? 1 : 0;

    storageAlarm.updateAlarmValue(key, hou, min, mon, tue, wed, thu, fri, sat, sun, tone, vibrate);
}

function addAlarm () {
    var hou = alarmPage.hourValue + alarmPage.morehours,
        min = alarmPage.minuteValue,
        mon = (checkMon.checked == true) ? 1 : 0,
        tue = (checkTue.checked == true) ? 1 : 0,
        wed = (checkWed.checked == true) ? 1 : 0,
        thu = (checkThu.checked == true) ? 1 : 0,
        fri = (checkFri.checked == true) ? 1 : 0,
        sat = (checkSat.checked == true) ? 1 : 0,
        sun = (checkSun.checked == true) ? 1 : 0,
        tone = listTone.selectedIndex,
        vibrate = (vibrateSwitch.checked == true) ? 1 : 0;

    storageAlarm.setAlarmValue(hou, min, mon, tue, wed, thu, fri, sat, sun, tone, vibrate);
}

// Call Workerscript to populate the alarm list
function populateAlarm () {
    var msg = {'action': 'appendAlarm', 'model': listModel, 'array': storageAlarm.getAlarmValue()};
    worker.sendMessage(msg);
}

// Read preset from internal databese and populate the preset list
WorkerScript.onMessage = function (msg) {
    if (msg.action == 'appendAlarm') {
        var i = 0;
        var alarmarray = new Array();
        msg.model.clear();
        alarmarray = msg.array;
        for (i = 0; i < alarmarray.length; i++) {
            var data = { 'key': alarmarray[i][0], 'hou': alarmarray[i][1], 'min':  alarmarray[i][2], 'mon':  alarmarray[i][3], 'tue':  alarmarray[i][4], 'wed':  alarmarray[i][5], 'thu':  alarmarray[i][6], 'fri':  alarmarray[i][7], 'sat':  alarmarray[i][8], 'sun':  alarmarray[i][9], 'ton':  alarmarray[i][10], 'vib':  alarmarray[i][11], 'act':  alarmarray[i][12] };
            msg.model.append(data);
            msg.model.sync();   // updates the changes to the list
        }
    }
}

function getAlarm () {
    oneAlarm = storageAlarm.getActiveAlarm();
}

function getFirstAlarm () {
    var hoursnow = parseInt(Qt.formatDateTime(new Date(), "hh")),
        minutesnow = parseInt(Qt.formatDateTime(new Date(), "mm")),
        firstAlarm = new Array,
        x;

    firstAlarm = storageAlarm.getActiveAlarm();

    if (firstAlarm.length > 0) {
        for (x = 0; x < firstAlarm.length; x++) {
            var totmininhoursnow = (hoursnow * 60) + minutesnow;
            var totmininhours = (parseInt(firstAlarm[x][1]) * 60) + parseInt(firstAlarm[x][2]);
            if (hoursnow > parseInt(firstAlarm[x][1]) || (hoursnow == parseInt(firstAlarm[x][1]) && minutesnow > parseInt(firstAlarm[x][2]))) {
                totmininhours += 1440;
            }
            if (totmininhoursnow < totmininhours) {
                labelNoAlarm.visible = false;
                labelHeaderNextAlarm.visible = true;
                var totminutestoalarm = totmininhours - totmininhoursnow;
                var hourstoalarm = parseInt(totminutestoalarm / 60);
                var change = totminutestoalarm - (hourstoalarm * 60);
                var viewhourstoalarm = hourstoalarm + firstAlarm[x][13];
                if (viewhourstoalarm < 24) {
                    labelNextAlarm.text = viewhourstoalarm + " h " + change + " min";
                } else {
                    var viewdaystoalarm = parseInt(viewhourstoalarm / 24);
                    var changehours = viewhourstoalarm - (viewdaystoalarm * 24);
                    labelNextAlarm.text = viewdaystoalarm + " d " + changehours + " h " + change + " min";
                }
                labelNextAlarm.visible = true;
                if (circleMinutes.state == "NORMAL" || circleMinutes.state == "LISTALARM") {
                    hourslabelTimer.text = zeroleft(firstAlarm[x][1], 2);
                    minuteslabelTimer.text =  zeroleft(firstAlarm[x][2], 2);
                    minuteHand.colorhand = Theme.palette.normal.baseText;
                    minuteHand.colortop = Theme.palette.normal.baseText
                    hourHand.colorhand = Theme.palette.normal.baseText
                    hourslabelTimer.color = Theme.palette.normal.baseText
                    minuteslabelTimer.color = Theme.palette.normal.baseText
                    colonTimer1.color = Theme.palette.normal.baseText
                    var angleHour = (parseInt(firstAlarm[x][1]) > 12) ? parseInt(firstAlarm[x][1]) - 12 : parseInt(firstAlarm[x][1]);
                    hourHand.rotationAngle = angleHour * 30;
                    minuteHand.rotationAngle = parseInt(firstAlarm[x][2]) * 6;
                    alarmSwitch.checked = true;
                    var alarmText = strTypeAlarm(firstAlarm[x][6], firstAlarm[x][7], firstAlarm[x][8], firstAlarm[x][9], firstAlarm[x][10], firstAlarm[x][11], firstAlarm[x][12]);
                    if (alarmText == "Never") {
                        typelabelAlarm.text = "";
                    } else if (alarmText) {
                        typelabelAlarm.text = alarmText;
                    }
                }
                getAlarm();
                break;
            }
        }
    } else {
        labelHeaderNextAlarm.visible = false;
        labelNextAlarm.visible = false;
        labelNoAlarm.visible = true;
        if (circleMinutes.state == "NORMAL" || circleMinutes.state == "LISTALARM") {
            hourslabelTimer.text = "00";
            minuteslabelTimer.text =  "00";
            minuteHand.colorhand = Theme.palette.normal.baseText
            minuteHand.colortop = Theme.palette.normal.baseText
            hourHand.colorhand = Theme.palette.normal.baseText
            hourslabelTimer.color = Theme.palette.normal.baseText
            minuteslabelTimer.color = Theme.palette.normal.baseText
            colonTimer1.color = Theme.palette.normal.baseText
            hourHand.rotationAngle = 0 * 30;
            minuteHand.rotationAngle = 0 * 6;
            alarmSwitch.checked = false;
            typelabelAlarm.text = "";
        }
        getAlarm();
    }
}

function strTypeAlarm (mon, tue, wed, thu, fri, sat, sun) {
    var labeltext;

    if (mon == 0 && tue == 0 && wed == 0 && thu == 0 && fri == 0 && sat == 0 && sun == 0) {
        labeltext = "Never";
    } else if (mon == 1 && tue == 1 && wed == 1 && thu == 1 && fri == 1 && sat == 1 && sun == 1) {
        labeltext = "Every day";
    } else if (mon == 1 && tue == 1 && wed == 1 && thu == 1 && fri == 1 && sat == 0 && sun == 0) {
        labeltext = "Mon-Fri";
    } else if (mon == 0 && tue == 0 && wed == 0 && thu == 0 && fri == 0 && sat == 1 && sun == 1) {
        labeltext = "Sat-Sun";
    } else {
        labeltext = (mon == 1) ? "Mon" : "";
        labeltext += (tue == 1) ? " Tue" : "";
        labeltext += (wed == 1) ? " Wed" : "";
        labeltext += (thu == 1) ? " Thu" : "";
        labeltext += (fri == 1) ? " Fri" : "";
        labeltext += (sat == 1) ? " Sat" : "";
        labeltext += (sun == 1) ? " Sun" : "";
    }

    return labeltext;
}
