/*
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Nekhelesh Ramananthan <krnekhelesh@gmail.com>
 *              Renato Araujo Oliveira Filho <renato.filho@canonical.com>
 */

import QtQuick 2.0
import Ubuntu.Components 0.1

Flickable {

    //oldContentY: stores the value of contentY when flick movement started
    property int oldContentY: 0
    //direction: stores the direction (+ or -) and the difference
    //between the old and new values of contentY
    property int direction: contentY - oldContentY
    //Holds the number of pixels that has to move to trigger view change
    property int swipeTolerance: 10

    clip: true
    anchors.fill: parent
    contentWidth: parent.width
    contentHeight: units.gu(87)

    onMovementStarted: oldContentY = contentY

    onMovementEnded: {
            if(direction > swipeTolerance)
                contentY = contentHeight - parent.height
            else if(direction < -swipeTolerance)
                contentY = 0;
        }

    Behavior on contentY {
            UbuntuNumberAnimation { duration: UbuntuAnimation.SlowDuration }
        }
}
