import QtQuick 2.0
import Ubuntu.Components 0.1

Rectangle {
    id: stopwatchBlip

    property int location: 0
    property real radAngle: ((location % 60 * -6) * Math.PI / 180) - Math.PI
    property real distance: 0.50
    property real size: 2

    z: parent.z - 1
    width: units.gu(size); height: units.gu(size)
    radius: width / 2
    anchors.centerIn: parent
    color: Theme.palette.normal.baseText
    antialiasing: true
    visible: false

    // Position the blip at the correct position
    transform: Translate {
        x: parent.width * distance * Math.sin(radAngle)
        y: parent.height * distance * Math.cos(radAngle)
    }

    // Increase the radius and decrease the opacity gradually
    Behavior on location {
        ParallelAnimation {
            running: false
            NumberAnimation { target: stopwatchBlip; property: "size"; from: 1; to: 7; duration: 3500; easing.type: Easing.OutQuad}
            NumberAnimation { target: stopwatchBlip; property: "opacity"; from: 1; to: 0; duration: 3500; easing.type: Easing.OutQuad}
        }
    }

}

