/*
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Nekhelesh Ramananthan <krnekhelesh@gmail.com>
 */

Qt.include("../common/ClockUtils.js")

// Array to hold the difference between start and current time (hours, minutes, seconds, milliseconds)
var deltaTime = [0,0,0,0];

// Function to convert time(in milliseconds) to hh:mm:ss:ms format
function msToTime(time) {
    var hours, minutes, seconds, milliseconds;

    milliseconds = Math.floor(time % 1000 / 100)
    time = Math.floor(time / 1000)
    seconds = time % 60
    time = Math.floor(time / 60)
    minutes = time % 60
    hours = Math.floor(time / 60)

    return [hours, minutes, seconds, milliseconds];
}

// Function to convert time (hh:mm:ss:ms) to milliseconds
function timeToMs(now) {
    return ((now.getHours() * 60 * 60) + (now.getMinutes() * 60) + now.getSeconds()) * 1000 + now.getMilliseconds();
}

// Function to print Stopwatch label (format mm:ss.ms and hh:mm:ss.ms when mm > 59) at top
function intervalToString(hours, minutes, seconds, milliseconds)
{
    var locale = Qt.locale();

    if (hours > 0) {
        return zeroleft(hours, 2) + ":" + zeroleft(minutes, 2) + ":" + zeroleft(seconds, 2) + locale.decimalPoint + numberToLocaleString(milliseconds);
    } else {
        return zeroleft(minutes, 2) + ":" + zeroleft(seconds, 2) + locale.decimalPoint + numberToLocaleString(milliseconds);
    }
}

// Function to calculate the difference between start and current time
function delta() {
    return Math.abs(timeToMs(new Date()) - analogStopwatch.startTime);
}

// Function to calculate the current lap time
function currentLapLabel(now, lapStart) {
    var current = msToTime(Math.abs(now - lapStart));
    return intervalToString(current[0], current[1], current[2], current[3]);
}
